Application Description: /*-----------------------------------------------------------------------------
		 TYPE:				APL Centura	
		 FILE NAME:			WINAPI.APL
		-------------------------------------------------------------------------------
		 PURPOSE:
			API Windows 32 bit Message et functions
			Source=USER32.DLL et GDI32.DLL, Windows.H
		-------------------------------------------------------------------------------
		 MODIFICATION HISTORY:
		 Auth			Date		Comment
		-------------------------------------------------------------------------------
		R&D lc			16/04/1996	Cration
	Outline Version - 4.0.27
	Design-time Settings
.data VIEWINFO
0000: 6F00000001000000 FFFF01000D004347 5458566965775374 6174650400010000
0020: 0000000000B00000 002C000000020000 0003000000FFFFFF FFFFFFFFFFFCFFFF
0040: FFE9FFFFFF180000 0018000000500300 00BD010000010000 0000000000010000
0060: 000F4170706C6963 6174696F6E497465 6D00000000
.enddata
		Outline Window State: Maximized
		Outline Window Location and Size
.data VIEWINFO
0000: 6600040003001B00 0200000000000000 0000E91EB20C0500 1D00FFFF4D61696E
0020: 0029000100040068 0000000000E91E80 0A00008600FFFF49 6E7465726E616C20
0040: 46756E6374696F6E 7300200001000400 670000000000E91E 800A0000DF00FFFF
0060: 5661726961626C65 73001E0001000400 6A0000000000F51E 100D0000F400FFFF
0080: 436C617373657300
.enddata
.data VIEWSIZE
0000: 8800
.enddata
			Left: -0.013"
			Top:    0.0"
			Width:  8.013"
			Height: 4.969"
		Options Box Location
.data VIEWINFO
0000: D4180909B80B1A00
.enddata
.data VIEWSIZE
0000: 0800
.enddata
			Visible? Yes
			Left: 4.15"
			Top:    1.885"
			Width:  3.8"
			Height: 2.073"
		Class Editor Location
			Visible? No
			Left: 0.575"
			Top:    0.094"
			Width:  5.063"
			Height: 2.719"
		Tool Palette Location
			Visible? No
			Left: 5.55"
			Top:    1.177"
		Fully Qualified External References? No
		Reject Multiple Window Instances? Yes
		Enable Runtime Checks Of External References? Yes
		Use Release 4.0 Scope Rules? No
	Libraries
	Global Declarations
		Window Defaults
			Tool Bar
				Display Style? Etched
				Font Name: System Default
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Form Window
				Display Style? Etched
				Font Name: System Default
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Dialog Box
				Display Style? Etched
				Font Name: System Default
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Top Level Table Window
				Font Name: System Default
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Data Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Multiline Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Spin Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Background Text
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Pushbutton
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Radio Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Check Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Option Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Group Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Child Table Window
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			List Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Combo Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Line
				Line Color: Use Parent
			Frame
				Border Color: Use Parent
				Background Color: Use Parent
			Picture
				Border Color: Use Parent
				Background Color: Use Parent
		Formats
			Number: 0'%'
			Number: #0
			Number: ###000
			Number: ###000;'($'###000')'
			Date/Time: hh:mm:ss AMPM
			Date/Time: M/d/yy
			Date/Time: MM-dd-yy
			Date/Time: dd-MMM-yyyy
			Date/Time: MMM d, yyyy
			Date/Time: MMM d, yyyy hh:mm AMPM
			Date/Time: MMMM d, yyyy hh:mm AMPM
		External Functions
			Library name: USER32.DLL
				Function: GetWindow
					Description: Rcuprer l'application suivante sur le bureau
							2 me paramtre.
							GW_CHILD 5, GW_HWNDFIRST 0, GW_HWNDLAST 1,
							GW_HWNDNEXT 2, GW_HWNDPREV 3, GW_OWNER 4
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Number: WORD
				Function: DestroyWindow
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
				!
				Function: GetDC
					Description: Retrieves the handle of a device context for the client area of the 
							given window.
							
							Parameters:
								hWnd		Handle of window
							
							Return Value:
								Handle of the device context for the given window's client area
					Export Ordinal: 0
					Returns
						Number: WORD
					Parameters
						Window Handle: HWND
				Function: ReleaseDC
					Description: Releases the given device context
							
							Parameters:
								hWnd	Identifies the window whose device context is to be released
								hDC	Identifies the device context to release
							
							Return Value:
								TRUE if the function is successful
					Export Ordinal: 0
					Returns
						Number: INT
					Parameters
						Window Handle: HWND
						Number: WORD
				Function: GetFocus
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
				!
				Function: GetCursorPos
					Description: void GetCursorPos(lppt)
							
							POINT FAR* lppt;	/* address of structure for cursor position	*/
							
							The GetCursorPos function retrieves the screen coordinates of the cursor's current position. 
					Export Ordinal: 0
					Returns
					Parameters
						structPointer
							Receive Number: LONG
							Receive Number: LONG
				Function: ShowWindow
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						Number: INT
				Function: GetActiveWindow
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
				Function: WindowFromPoint 
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Number: LONG
						Number: LONG
				Function: IsWindow
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
				!
				Function: GetWindowLongA
					Description:
					Export Ordinal: 0
					Returns
						Number: LONG
					Parameters
						Window Handle: HWND
						Number: INT
				Function: SetWindowLongA
					Description:
					Export Ordinal: 0
					Returns
						Number: LONG
					Parameters
						Window Handle: HWND
						Number: INT
						Number: LONG
				!
				Function: GetClientRect
					Description: The GetClientRect function retrieves the coordinates of a window's 
							client area. The client coordinates specify the upper-left and lower-right
							 corners of the client area. Because client coordinates are relative
							 to the upper-left corner of a window's client 
							area, the coordinates of the upper-left corner are (0,0). 
							
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						structPointer
							Receive Number: INT
							! Left
							Receive Number: INT
							! Top
							Receive Number: INT
							! Right
							Receive Number: INT
							! Bottom
				Function: GetWindowRect
					Description: The GetWindowRect function retrieves the dimensions of the bounding
							 rectangle of the specified window. The dimensions are given in screen
							 coordinates that are relative to the upper-left corner of the screen. 
							
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						structPointer
							Receive Number: INT
							Receive Number: INT
							Receive Number: INT
							Receive Number: INT
				!
				Function: CreatePopupMenu
					Description:
					Export Ordinal: 0
					Returns
						Number: WORD
					Parameters
				Function: TrackPopupMenu
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: WORD
						Number: INT
						Number: INT
						Number: INT
						Number: INT
						Window Handle: HWND
						String: LPSTR
				Function: ClientToScreen 
					Description:
					Export Ordinal: 0
					Returns
					Parameters
						Window Handle: HWND
						structPointer
							Receive Number: INT
							Receive Number: INT
				Function: AppendMenuA
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: LONG
						Number: INT
						Number: INT
						String: LPSTR
				!
				Function: LoadCursorA
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Number: DWORD
				Function: SetCursor
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
				Function: SetClassLongA
					Description:
					Export Ordinal: 0
					Returns
						Number: DWORD
					Parameters
						Window Handle: HWND
						Number: INT
						Number: LONG
				Function: SetCapture
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
				Function: ReleaseCapture
					Description:
					Export Ordinal: 0
					Returns
					Parameters
				Function: GetMenu
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
				Function: EnableMenuItem
					Description:
					Export Ordinal: 0
					Returns
					Parameters
						Window Handle: HWND
						Number: UINT
						Number: UINT
				Function: GetSystemMenu
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Boolean: BOOL
				Function: GetKeyState
					Description:
					Export Ordinal: 0
					Returns
						Number: SHORT
					Parameters
						Number: INT
				Function: GetAsyncKeyState
					Description:
					Export Ordinal: 0
					Returns
						Number: SHORT
					Parameters
						Number: INT
				!
				Function: FindWindowA
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						String: LPSTR
				Function: GetWindowTextA
					Description:
					Export Ordinal: 0
					Returns
						Number: INT
					Parameters
						Window Handle: HWND
						String: LPSTR
						Number: INT
				Function: SetForegroundWindow
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
				Function: GetTopWindow
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
				Function: ScreenToClient
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Window Handle: HWND
						structPointer
							Receive Number: INT
							Receive Number: INT
				Function: GetDlgItem
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Number: LONG
				Function: SetParent
					Description:
					Export Ordinal: 0
					Returns
						Window Handle: HWND
					Parameters
						Window Handle: HWND
						Window Handle: HWND
				!
				Function: LoadImageA
					Description:
					Export Ordinal: 0
					Returns
						Number: HANDLE
					Parameters
						Number: HANDLE
						String: LPCSTR
						Number: UINT
						Number: INT
						Number: INT
						Number: UINT
				Function: DestroyIcon
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: HANDLE
			Library name: GDI32.DLL
				!
				! Function: GetTextExtent
					Description: Computes the height and width of a line of text, 
							using the current font to compute the dimensions.
							
							Parameters:
								hDC		Identifies the device context
								lpszString	Points to a Character String
								cbString		Specifies the number of bytes in the string.
							
							Return Value:
								The low-order word of contains the string width, the high-order 
								word contains the string height.
					Export Ordinal: 207
					Returns 
						Number: DWORD
					Parameters 
						Number: WORD
						String: LPSTR
						Number: INT
				Function: GetTextExtentPoint32A
					Description: Computes the height and width of a line of text, 
							using the current font to compute the dimensions.
							
							Parameters:
								hDC		Identifies the device context
								lpszString	Points to a Character String
								cbString		Specifies the number of bytes in the string.
								LPSIZE  lpSize 	// address of structure for string size.
							
							Return Value:
								If the function succeeds, the return value is TRUE.
								If the function fails, the return value is FALSE. To get extended error information, call GetLastError. 
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: WORD
						String: LPSTR
						Number: INT
						structPointer
							Receive Number: LONG
							Receive Number: LONG
				Function: SelectObject
					Description: Selects an object into the given device context.  The new object replaces 
							the previous object of the same type.
							
							Parameters:
								hDC		Identifies the device context
								hGDIObj		Identifies the object to be selected.
							
							Return Value:
								The return value is the handle of the object being replaced.
					Export Ordinal: 0
					Returns
						Number: WORD
					Parameters
						Number: WORD
						Number: WORD
				!
			Library name: SHELL32.DLL
				Function: ShellExecuteA
					Description:
					Export Ordinal: 0
					Returns
					Parameters
						Window Handle: HWND
						String: LPSTR
						String: LPSTR
						String: LPSTR
						String: LPSTR
						Number: INT
		Constants
.data CCDATA
0000: 3000000000000000 0000000000000000 00000000
.enddata
.data CCSIZE
0000: 1400
.enddata
			System
				!
				! ---------------------------------------------------------------------------------------------------------------------
				! ------------------------------------- Constantes WINAPI.APL ----------------------------------------------
				! ---------------------------------------------------------------------------------------------------------------------
				!
				! Messages MS-Windows Entres/Sorties souris/clavier
				! Pour plus d'information, reportez vous  la documentation Visual ++ Section: Messages
				! --- Messages MS-Windows Entres/Sorties souris/clavier/fentre
				! ====
				Number: BM_SETCHECK = 0x0401
				Number: WM_SIZE			=	0x0005
				Number: WM_CHAR 		= 	0x0102
				Number: WM_KEYDOWN     		= 	0x0100
				Number: WM_KEYUP 		= 	0x0101
				Number: WM_LBUTTONDBLCLK	=	0x0203
				Number: WM_LBUTTONDOWN 	=	0x0201
				Number: WM_LBUTTONUP 		= 	0x0202
				Number: WM_MENUSELECT 	=	0x011F
				Number: WM_MOUSEMOVE 		= 	0x0200
				Number: WM_MOVE		= 	0x0003
				Number: WM_RBUTTONDOWN	=	0x0204
				Number: WM_RBUTTONUP 		=	0x0205
				Number: WM_SETFOCUS 		=	0x0007
				Number: WM_COMMAND		=	0x0111
				Number: WM_SYSCOMMAND	=	0x0112
				Number: WM_SYSKEYUP 		=	0x0105
				Number: WM_MDIACTIVATE		=	0x0222
				Number: WM_CHILDACTIVATE	=	0x0022
				Number: WM_WINPOSCHANGED	=	0x0047
				Number: WM_GETDLGCODE		=	0x0087
				Number: WM_SETCURSOR		=	0x0020
				Number: WM_NCCALCSIZE		=	0x0083
				Number: WM_CUT			=	0x0300
				Number: WM_COPY		=	0x0301
				Number: WM_PASTE		=	0x0302
				Number: WM_CLEAR		=	0x0303
				Number: WM_UNDO		=	0x0304
				Number: WM_PAINT		=	0x000F
				Number: WM_GETICON		= 	0x007F
				Number: WM_SETICON		= 	0x0080
				!
				! Messages MS-Windows de Management des fentres parentes
				! Pour plus d'information, reportez vous  la documentation Visual ++
				Number: SC_CLOSE		=	0xF060
				Number: SC_MAXIMIZE		=	0xF030
				Number: SC_MINIMIZE		=	0xF020
				Number: SC_NEXTWINDOW	=	0xF040
				Number: SC_PREVWINDOW	=	0xF050
				Number: SC_RESTORE		=	0xF120
				!
				Number: WM_NCCREATE 		= 	0x0081
				Number: WM_GETFONT 		= 	0x0031
				!
				Number: SW_SHOWNOACTIVATE	= 	4
				!
				! Window field offsets for GetWindowLong() and GetWindowWord()
				Number: GWL_WNDPROC		=	-4
				Number: GWW_HINSTANCE	=	-6
				Number: GWW_HWNDPARENT	=	-8
				Number: GWW_ID			=	-12
				Number: GWL_STYLE		=	-16
				Number: GWL_EXSTYLE         	=	-20
				! -------  Basic window types
				Number: WS_OVERLAPPED       	=	0x00000000
				Number: WS_POPUP            		=	0x80000000
				Number: WS_CHILD            		=	0x40000000
				! -------  Clipping styles
				Number: WS_CLIPSIBLINGS     	=	0x04000000
				Number: WS_CLIPCHILDREN     	=	0x02000000
				! -------  Generic window states
				Number: WS_VISIBLE          		=	0x10000000
				Number: WS_DISABLED         	=	0x08000000
				! Main window states
				Number: WS_MINIMIZE         	=	0x20000000
				Number: WS_MAXIMIZE         	=	0x01000000
				! -------  Main window styles
				Number: WS_CAPTION          	=	0x00C00000     ! WS_BORDER | WS_DLGFRAME  
				Number: WS_BORDER           	=	0x00800000
				Number: WS_DLGFRAME         	=	0x00400000
				Number: WS_VSCROLL          	=	0x00200000
				Number: WS_HSCROLL          	=	0x00100000
				Number: WS_SYSMENU          	=	0x00080000
				Number: WS_THICKFRAME       	=	0x00040000
				Number: WS_MINIMIZEBOX      	=	0x00020000
				Number: WS_MAXIMIZEBOX	=	0x00010000
				! -------  Control window styles
				Number: WS_GROUP            	=	0x00020000
				Number: WS_TABSTOP          	=	0x00010000
				! -------  Common Window Styles
				Number: WS_OVERLAPPEDWINDOW	=	(WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
				Number: WS_POPUPWINDOW		=	(WS_POPUP | WS_BORDER | WS_SYSMENU)
				Number: WS_CHILDWINDOW		=	(WS_CHILD)
				! -------  Extended Window Styles
				Number: WS_EX_DLGMODALFRAME	=	0x00000001
				Number: WS_EX_NOPARENTNOTIFY	=	0x00000004
				! -------  if (WINVER >= 0x030a)
				Number: WS_EX_TOPMOST          	=	0x00000008
				Number: WS_EX_ACCEPTFILES	=	0x00000010
				Number: WS_EX_TRANSPARENT	=	0x00000020
				!
				Number: WS_EX_TOOLWINDOW	=	0x00000080
				! Message servant  forcer la slection d'un champ
				Number: EM_GETSEL		=	0x00B0	! Get the selected text
				Number: EM_SETSEL		=	0x00B1	! Set the selected text
				Number: EM_SETREADONLY    	= 	0x00CF
				!
				Number: IDC_ARROW		=	32512	! Cursor flche
				Number: IDC_CROSS		=	32515	! Cursor croix
				!
				Number: GCL_HCURSOR		=	-12	! SetClassLong paramtre Window and Class Words
				!
				!
				! Option de menu 
				Number: MF_INSERT		=	0x00000000
				Number: MF_CHANGE		=	0x00000080
				Number: MF_APPEND		=	0x00000100
				Number: MF_DELETE		=	0x00000200
				Number: MF_REMOVE		=	0x00001000
				!
				Number: MF_BYCOMMAND		=	0x00000000
				Number: MF_BYPOSITION		=	0x00000400
				!
				Number: MF_SEPARATOR		=	0x00000800
				!
				Number: MF_ENABLED		=	0x00000000
				Number: MF_GRAYED		=	0x00000001
				Number: MF_DISABLED		=	0x00000002
				!
				Number: MF_UNCHECKED		=	0x00000000
				Number: MF_CHECKED		=	0x00000008
				Number: MF_USECHECKBITMAPS	=	0x00000200
				!
				Number: MF_POPUP		=	0x00000010
				Number: MF_MENUBARBREAK	=	0x00000020
				Number: MF_MENUBREAK		=	0x00000040
				!
				Number: MF_ALL_ENABLED		=	0xFFFFFFFF
				Number: MF_ALL_DISABLED		=	0x00000000
				!
				Number: LR_LOADFROMFILE 	= 	0x0010
				Number: LR_SHARED           		=	0x8000
				Number: IMAGE_ICON		= 	1
				Number: ICON_SMALL		= 	0
			User
		Resources
		Variables
		Internal Functions
		Named Menus
		Class Definitions
		Default Classes
			MDI Window: cBaseMDI
			Form Window:
			Dialog Box:
			Table Window:
			Quest Window:
			Data Field:
			Spin Field:
			Multiline Field: cQuickMLField
			Pushbutton: cQuickCommander
			Radio Button:
			Option Button:
			ActiveX:
			Check Box:
			Child Table: cQuickTable
			Quest Child Window: cQuickDatabase
			List Box:
			Combo Box:
			Picture: cQuickPicture
			Vertical Scroll Bar:
			Horizontal Scroll Bar:
			Column:
			Background Text:
			Group Box:
			Line:
			Frame:
			Custom Control: cQuickGraph
		Application Actions
